%define project fdr

Summary: GNU cfengine - a systems administration tool for networks
Name: cfengine
Epoch: 0
Version: 2.1.0
Release: 0.%{project}.2.p1.rh90
License: GPL
Group: System Environment/Daemons
Source0: ftp://ftp.iu.hio.no/pub/cfengine/cfengine-2.1.0p1.tar.gz
Source1: cfexecd
Source2: cfservd
Source3: cfenvd
URL: http://www.cfengine.org/
BuildRequires: db4-devel,openssl-devel,tetex,bison,flex,m4
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Cfengine, or the configuration engine is an agent/software robot and a
very high level language for building expert systems to administrate
and configure large computer networks. Cfengine uses the idea of
classes and a primitive form of intelligence to define and automate
the configuration and maintenance of system state, for small to huge
configurations. Cfengine is designed to be a part of a computer immune
system.

#---------------------------------------------------------------------

%prep
%setup -n %{name}-%{version}p1

#---------------------------------------------------------------------

%build
# Since /usr is managed by rpmdb, we can build stuff in there
# instead of putting all this stuff under /usr/local
# ./configure BERKELEY_DB_LIB=-ldb --prefix=/usr --infodir=/usr/share/info
%configure BERKELEY_DB_LIB=-ldb 
make

# Some of the example files have execute bit for some reason.
chmod 644 inputs/*example
#---------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
make DESTDIR=$RPM_BUILD_ROOT install
# make directory tree for cfengine configs
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/%{name}
for i in ppkeys inputs outputs
do
 	mkdir -m 0700 $RPM_BUILD_ROOT%{_localstatedir}/%{name}/$i
done

# It's ugly, but thats the way Mark wants to have it. :(
# If we don't create this link, cfexecd will not be able to start
# (hardcoded) /var/sbin/cfagent in scheduled intervals. Other option 
# would be to patch cfengine to use %{_sbindir}/cfagent
mkdir -p $RPM_BUILD_ROOT/var/cfengine/bin
ln -sf %{_sbindir}/cfagent $RPM_BUILD_ROOT/var/cfengine/bin/

# Startup file for cfexecd and cfservd
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
for i in %{SOURCE1} %{SOURCE2} %{SOURCE3}
do
	install -m 0755 $i $RPM_BUILD_ROOT%{_initrddir}/
done

#
# Appearantly this %{_infodir}/dir gets build on RH9, but it doesn't
# appear in my RH8 box. Confusing situation...
#
if [ -f $RPM_BUILD_ROOT%{_infodir}/dir ]; then
	rm -f $RPM_BUILD_ROOT%{_infodir}/dir
fi
if [ -f NEWS -a -z "`cat NEWS`" ]; then
	rm -f NEWS
fi
#
# All this stuff is pushed into doc directory.
#
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name} 
#---------------------------------------------------------------------

%post
# cfagent won't run nicely, unless your host has keys.
if [ ! -d /mnt/sysimage -a ! -f %{_localstatedir}/%{name}/ppkeys/localhost.priv ]; then
	%{_sbindir}/cfkey
	/sbin/install-info --info-dir=%{_infodir} %{_infodir}/cfengine*.info* 2> /dev/null || :
fi
if [ "$1" = "1" ]; then
	chkconfig --add cfenvd
	chkconfig --add cfexecd
	chkconfig --add cfservd
	chkconfig cfenvd off
	chkconfig cfexecd off
	chkconfig cfservd off
fi
%preun
if [ "$1" = "0" ]; then
        /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cfengine*.info* 2> /dev/null || :
	chkconfig --del cfenvd
	chkconfig --del cfexecd
	chkconfig --del cfservd
fi

#---------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

#---------------------------------------------------------------------

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING DOCUMENTATION README TODO
%doc contrib
%doc inputs
%doc doc/*html
%{_mandir}/man8/*
%{_infodir}/cfengine*
%{_sbindir}/*
%config(noreplace) %{_initrddir}/cfenvd
%config(noreplace) %{_initrddir}/cfexecd
%config(noreplace) %{_initrddir}/cfservd
/var/cfengine/bin
%dir %{_localstatedir}/%{name}
%dir %{_localstatedir}/%{name}/inputs
%dir %{_localstatedir}/%{name}/outputs
%dir %{_localstatedir}/%{name}/ppkeys

#---------------------------------------------------------------------

%changelog
* Sun Nov 30 2003 Juha Ylitalo <jylitalo@iki.fi> - 0.2.1.0-0.fdr.2.p1
- FC1 requires m4 into BuildRequires.
* Tue Nov 11 2003 Juha Ylitalo <jylitalo@iki.fi> - 0.2.1.0-0.fdr.1.p1
- new upstream version
* Sat Sep 27 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.8-0.fdr.2.p1
- changed init.d to follow Fedora template
- got rid of duplicate example files
- moved example files into input directory
- fixed permissions on example files (removed execute permissions on them)

* Thu Sep 25 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.8-0.fdr.1.p1
- new upstream version

* Tue Sep 02 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.8-0.fdr.1
- new upstream version
- delete NEWS file if its zero bytes long.

* Tue Aug 12 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.7-0.fdr.4.p3
- chmod 644 for source0
- added missing signature to SRPM that comes out

* Mon Jul 21 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.7-0.fdr.3.p3
- fixed License from "GNU GPL" to GPL
- init.d scripts changed to be "config(noreplace)"

* Fri Jul 04 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.7-0.fdr.2.p3
- changes to version and release to apply with Fedora's Naming Guidelines
- dropped gcc from BuildRequires
- "2345" initlevels replaced with "-" in init.d scripts chkconfig part.
- added chkconfig into %post and %pre for all init.d scripts

* Wed Jun 25 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.7p3-0.fdr.1
- new upstream version.

* Sun May 04 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.6-0.fdr.4
- added init.d script for cfenvd.
- sanity checks for cfservd and cfexecd init.d script
- added outputs and ppkeys directories into %files list.

* Sun Apr 20 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.6-0.fdr.3
- set Group to "System Environment/Daemons", which is valid in RPM 4.2
  (old value was System/Utilities)

* Wed Apr 09 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.6-0.fdr.2
- fixed URL
- removed Requires as redundant
- remove %{_infodir}/dir from package, if it would exist 
  (which is not the case in RH8)

* Wed Apr 09 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.6-0.fdr.1
- upgrade from 2.0.5 to 2.0.6
- added install-info to %post and %preun
- added Epoch
- changed all paths that are not hard coded into %{_sbindir}, etc.
- changed ./configure to %configure
- changed URL to something you can cut&paste
- simplified %files list and yet added more stuff into %doc part.

* Wed Mar 26 2003 Juha Ylitalo <jylitalo@iki.fi> - 0:2.0.5-0.fdr.1
- upgrade from 2.0.4 to 2.0.5
- fedora related changes to spec file.

* Thu Sep 05 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.4-1
- new upstream version.

* Thu Jun 20 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.2-4
- added check that if we are doing initial install 
  (meaning that /mnt/sysimage is mounted), there is no point at
  running cfkey until system boots up with correct root directory

* Thu Jun 13 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.2-3
- fixed revision numberings to go on in sensible way
- added missing man page
- changed cfexecd and cfservd to start later 
  (assuming your using chkconfig for setting things)
- additional check in cfexecd start() for making sure that local cfkeys
  have been created.

* Wed May 29 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.2-1
- version upgrade
- support for clients using dynamic addresses (=DHCP)
- support for ip ranges
- bug fixes

* Thu May  9 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.1-2
- fixed first line in init.d scripts
- added chkconfig line into init.d scripts

* Wed May  1 2002 Juha Ylitalo <juha.ylitalo@iki.fi> - 2.0.1-1
- first public RPM...

